import { ApolloQueryResult } from '@apollo/client/core';
import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { Apollo } from './Apollo';
import { QueryRef } from './QueryRef';
import { WatchQueryOptionsAlone, QueryOptionsAlone, R } from './types';
export declare class Query<T = {}, V = R> {
    protected apollo: Apollo;
    readonly document: DocumentNode;
    client: string;
    constructor(apollo: Apollo);
    watch(variables?: V, options?: WatchQueryOptionsAlone<V>): QueryRef<T, V>;
    fetch(variables?: V, options?: QueryOptionsAlone<V>): Observable<ApolloQueryResult<T>>;
}
